﻿Imports MapInfo.Design

''' <summary>
''' DataGridEXクラス
''' </summary>
''' <remarks>Y.Kumada 2014/07/11</remarks>
Public Class DataGridViewEX

    Inherits DataGridView

    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    ''' <remarks>Y.Kumada 2014/07/10</remarks>
    Public Sub New()

        '/// ダブルバッファリングの設定(ちらつき防止)
        Me.DoubleBuffered = True

        'Me.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill

    End Sub

    ''' <summary>
    ''' マウスDown時の処理
    ''' </summary>
    ''' <param name="e">イベント</param>
    ''' <remarks>Y.Kumada 2014/07/11</remarks>
    Protected Overrides Sub OnMouseDown(e As System.Windows.Forms.MouseEventArgs)

        '/// 一時的にダブルバッファリングを止める
        Me.DoubleBuffered = False

        MyBase.OnMouseDown(e)

    End Sub

    ''' <summary>
    ''' マウスUp時の処理
    ''' </summary>
    ''' <param name="e">イベント</param>
    ''' <remarks>Y.Kumada 2014/07/11</remarks>
    Protected Overrides Sub OnMouseUp(e As System.Windows.Forms.MouseEventArgs)

        '/// ダブルバッファリングをONに
        Me.DoubleBuffered = True

        MyBase.OnMouseUp(e)

    End Sub

    ''' <summary>
    ''' セルクリック時の処理
    ''' </summary>
    ''' <param name="e">セルクリックイベント</param>
    Protected Overrides Sub OnCellClick(e As System.Windows.Forms.DataGridViewCellEventArgs)

        Formメイン.tssPosition.Text = e.RowIndex + 1 & "行、" & e.ColumnIndex + 1 & "列"
        Formメイン.tssRecord.Text = e.RowIndex + 1 & "/" & Me.RowCount

        MyBase.OnCellClick(e)
    End Sub

    ''' <summary>
    ''' セル移動時の処理
    ''' </summary>
    ''' <param name="e">イベント</param>
    Protected Overrides Sub OnCurrentCellChanged(e As System.EventArgs)

        If Me.CurrentCell IsNot Nothing Then

            Formメイン.tssPosition.Text = Me.CurrentCell.RowIndex + 1 & "行、" & Me.CurrentCell.ColumnIndex + 1 & "列"
            Formメイン.tssRecord.Text = Me.CurrentCell.RowIndex + 1 & "/" & Me.RowCount

        End If

        MyBase.OnCurrentCellChanged(e)

    End Sub

    'Protected Overrides Sub OnColumnMinimumWidthChanged(e As System.Windows.Forms.DataGridViewColumnEventArgs)

    '    Me.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill


    '    MyBase.OnColumnMinimumWidthChanged(e)
    'End Sub


End Class
