﻿Imports System.ComponentModel

''' <summary>
''' LabelEXSPクラス
''' </summary>
''' <remarks>Y.Kumada 2014/06/10</remarks>
Public Class LabelEXSP

    Inherits LabelEX

#Region "メンバ変数"
    Dim _backColor As Color
    Dim _foreColor As Color
    Dim _foreFont As Font

    Dim _myBaseBackColor As Color
    Dim _myBaseForeColor As Color
    Dim _myBaseFont As Font

    Dim _blnColorOn As Boolean
#End Region

#Region "コンストラクタ"
    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    Public Sub New()

        _blnColorOn = False

        _backColor = Me.BackColor
        _foreColor = Me.ForeColor
        _foreFont = Me.Font

        _myBaseBackColor = Me.BackColor
        _myBaseForeColor = Me.ForeColor
        _myBaseFont = Me.Font

    End Sub
#End Region

#Region "プロパティ"
    ''' <summary>
    ''' マウスが重なった時の背景の色
    ''' </summary>
    <Category("武田")> _
    <Description("マウスが重なった時の背景の色")> _
    Public Property MouseHoverBackColor() As Color
        Get
            Return _backColor
        End Get
        Set(value As Color)
            _backColor = value
        End Set
    End Property

    ''' <summary>
    ''' マウスが重なった時の前背景の色
    ''' </summary>
    <Category("武田")> _
    <Description("マウスが重なった時の前背景の色")> _
    Public Property MouseHoverForeColor() As Color
        Get
            Return _foreColor
        End Get
        Set(value As Color)
            _foreColor = value
        End Set
    End Property

    ''' <summary>
    ''' マウスが重なった時のフォント
    ''' </summary>
    <Category("武田")> _
    <Description("マウスが重なった時のフォント")> _
    Public Property MouseHoverFont() As Font
        Get
            Return _foreFont
        End Get
        Set(value As Font)
            _foreFont = value
        End Set
    End Property

    ''' <summary>
    ''' マウスがコントロールを離れた時の背景
    ''' </summary>
    <Category("武田")> _
    <Description("マウスがコントロールを離れた時の背景")> _
    Public Property MouseLeaveBackColor() As Color
        Get
            Return _myBaseBackColor
        End Get
        Set(value As Color)
            _myBaseBackColor = value
        End Set
    End Property

    ''' <summary>
    ''' マウスがコントロールを離れた時の背景
    ''' </summary>
    <Category("武田")> _
    <Description("マウスがコントロールを離れた時の背景")> _
    Public Property MouseLeaveForeColor() As Color
        Get
            Return _myBaseForeColor
        End Get
        Set(value As Color)
            _myBaseForeColor = value
        End Set
    End Property

    ''' <summary>
    ''' マウスがコントロールを離れた時のフォント
    ''' </summary>
    <Category("武田")> _
    <Description("マウスがコントロールを離れた時のフォント")> _
    Public Property MouseLeaveFont() As Font
        Get
            Return _myBaseFont
        End Get
        Set(value As Font)
            _myBaseFont = value
        End Set
    End Property
#End Region

#Region "イベントハンドラ"
    ''' <summary>
    ''' マウスが移動した際に発生するイベント
    ''' </summary>
    ''' <param name="e">マウスイベント</param>
    Protected Overrides Sub OnMouseMove(e As System.Windows.Forms.MouseEventArgs)
        Me.ForeColor = _foreColor
        Me.Font = _foreFont
        Me.BackColor = _backColor
        Me.Cursor = Cursors.Hand
        MyBase.OnMouseMove(e)
    End Sub

    ''' <summary>
    ''' マウスがコントロールを離れた時に発生するイベント
    ''' </summary>
    ''' <param name="e">イベント</param>
    Protected Overrides Sub OnMouseLeave(e As System.EventArgs)
        Me.ForeColor = _myBaseForeColor
        Me.Font = _myBaseFont
        Me.BackColor = _myBaseBackColor
        Me.Cursor = Cursors.Default
        MyBase.OnMouseLeave(e)
    End Sub
#End Region

End Class
