﻿Imports System.Drawing
Imports System.Windows.Forms

Public Class ProgressBarEx

    Inherits ProgressBar

    Public Sub New()
        'Paintイベントが発生するようにする
        'ダブルバッファリングを有効にする
        MyBase.SetStyle(ControlStyles.UserPaint Or ControlStyles.AllPaintingInWmPaint Or ControlStyles.OptimizedDoubleBuffer, True)
    End Sub

    Protected Overrides Sub OnPaint(e As PaintEventArgs)
        '背景を描画する
        ProgressBarRenderer.DrawHorizontalBar(e.Graphics, Me.ClientRectangle)

        'バーの幅を計算する
        '上下左右1ピクセルの枠の部分を除外して計算する
        Dim percent As Double = CDbl(Me.Value - Me.Minimum) / CDbl(Me.Maximum - Me.Minimum)
        Dim chunksWidth As Integer = CInt(CDbl(Me.ClientSize.Width - 2) * percent)
        Dim chunksRect As New Rectangle(1, 1, chunksWidth, Me.ClientSize.Height - 2)

        'バーを描画する
        ProgressBarRenderer.DrawHorizontalChunks(e.Graphics, chunksRect)

        '表示する文字列を決定する
        Dim displayText As String = String.Format("{0}%", CInt(Math.Truncate(percent * 100.0)))

        '文字列を描画する
        Dim tff As TextFormatFlags = TextFormatFlags.HorizontalCenter Or TextFormatFlags.VerticalCenter Or TextFormatFlags.SingleLine
        TextRenderer.DrawText(e.Graphics, displayText, Me.Font, Me.ClientRectangle, SystemColors.ControlText, tff)

    End Sub
End Class

