﻿Imports System.ComponentModel
Imports System.Windows.Forms


Public Class RadioButtonEx
    Inherits System.Windows.Forms.RadioButton

#Region "【メンバ変数】"

    ''' <summary>
    ''' 変更確認の有無
    ''' </summary>
    ''' <remarks></remarks>
    Private _chkEdit As Boolean

    ''' <summary>
    ''' 選択時太字ON/OFF
    ''' </summary>
    ''' <remarks></remarks>
    Private _chkBold As Boolean = True

#End Region

#Region "【拡張プロパティ】"

#Region "[CheckEdit] - 変更確認の有無"
    ''' <summary>
    ''' 変更確認の有無
    ''' </summary>
    ''' <value>Boolean</value>
    ''' <returns>Boolean</returns>
    ''' <remarks>変更確認有無</remarks>
    <Category("武田")> _
    <Description("エディットコントロール変更時に、変更確認を行うかを指定します。")> _
    <Browsable(True)> _
    <DefaultValue(False)> _
    Public Property CheckEdit() As Boolean

        Get
            Return _chkEdit
        End Get

        Set(ByVal value As Boolean)
            _chkEdit = value
        End Set

    End Property
#End Region

#Region "[CheckedBold] - 選択時の太字ON/OFF"
    ''' <summary>
    ''' 選択時の太字ON/OFF
    ''' </summary>
    ''' <value>Boolean</value>
    ''' <returns>Boolean</returns>
    ''' <remarks>選択時の太字ON/OFF</remarks>
    <Category("武田")> _
    <Description("エディットコントロールが選択状態の時に太字にするかの指定をします。")> _
    <Browsable(True)> _
    <DefaultValue(True)> _
    Public Property CheckedBold() As Boolean

        Get
            Return _chkBold
        End Get

        Set(ByVal value As Boolean)
            _chkBold = value
        End Set

    End Property
#End Region

#End Region

#Region "【拡張イベント】"

#Region "[OnCheckedChanged] - 選択状態変更拡張イベント"
    Protected Overrides Sub OnCheckedChanged(ByVal e As System.EventArgs)
        Dim _befFont As Font

        MyBase.OnCheckedChanged(e)

        _befFont = Me.Font

        If Me.Checked Then
            If _chkBold Then
                Me.Font = New Font(_befFont, FontStyle.Bold)
            Else
                Me.Font = New Font(_befFont, FontStyle.Regular)
            End If
        Else
            Me.Font = New Font(_befFont, FontStyle.Regular)
        End If

        If _chkEdit Then
            Call SetEditFlg(True)
        End If
    End Sub
#End Region

#Region "[OnKeyDown] - キー押下拡張イベント"
    ''' <summary>
    ''' キー押下時
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        MyBase.OnKeyDown(e)

        Select Case e.KeyCode
            Case Keys.Enter
                SendKeys.Send("{TAB}")
        End Select

    End Sub
#End Region

#End Region

#Region "【メソッド】"

#Region "[SetEditFlg] - フォームのblnEditFlgに [flg] を設定"
    ''' <summary>
    ''' フォームのblnEditFlgに [flg] を設定
    ''' </summary>
    ''' <param name="flg"></param>
    ''' <remarks></remarks>
    Public Sub SetEditFlg(ByVal flg As Boolean)
        gblnEditFlg = flg
    End Sub
#End Region

#End Region

End Class

